
;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of ProtonSmoke: An Amstrad CPC Shoot 'Em Up Game
;; Copyright (C) 2017 Daniel Finestrat Martinez (@DanielFinestrat)
;; Copyright (C) 2017 Angel Navarro Martinez (@EingelNavarro)
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.area _CODE

;; ================================================================================
;; ================================================================================
;; PRIVATE DATA
;; ================================================================================
;; ================================================================================

.include "cpctelera.h.s"
.include "bullet.h.s"
.include "functions.h.s"
.include "powerup.h.s"
.include "barril.h.s"
.include "enemy.h.s"
.include "menu.h.s"
.include "enemy.h.s"
.include "collision.h.s"
.include "assets.h.s"
.include "sfx.h.s"
.include "piezas.h.s"
.include "macros.h.s"

.globl change_dead
.globl save_all_last_variables
.globl doDrawing
.globl doErasing



;; Animations
hero_animation_up:
	hero_up_0: 		.dw	#_pre_Frame1
	hero_up_1:		.dw #_pre_Frame1a
	hero_up_2: 		.dw	#_pre_Frame1
	hero_up_3:		.dw #_pre_Frame1b

hero_animation_left:
	hero_left_0:	.dw #_pre_Frame2
	hero_left_1:	.dw #_pre_Frame2a
	hero_left_2:	.dw #_pre_Frame2
	hero_left_3:	.dw #_pre_Frame2b

hero_animation_right:
	hero_right_0:	.dw #_pre_Frame3
	hero_right_1:	.dw #_pre_Frame3a
	hero_right_2:	.dw #_pre_Frame3
	hero_right_3:	.dw #_pre_Frame3b


	hero_sprite_dir:			.dw #hero_animation_up
hero_variables::
	hero_x:						.db #48				;; Posicion en X del heroe en bytes
	hero_y:						.db #160			;; Posicion en Y del heroe en bytes
	hero_width:					.db #4				;; Ancho del hero en bytes
	hero_height:				.db #10				;; Altura del heroe en bytes
	hero_last_x:				.db #34
	hero_last_y:				.db #160
	hero_sprite:				.dw #_pre_Frame1
	hero_shooting_cooldown:		.db #15
	hero_moving_x:				.db #0
	hero_moving_y:				.db #0
	hero_points_3:				.db #0
	hero_points_2:				.db #0
	hero_points_1:				.db #0
	hero_lifes:					.db #3
	hero_frame_anime:			.db #2

;; INPUT
hero_input::
	hero_left:				.db #0x08, #0x20	;; Key_A
	hero_right:				.db #0x07, #0x20	;; Key_D
	hero_up:				.db #0x07, #0x08	;; Key_W
	hero_down:				.db #0x07, #0x10	;; Key_S
	hero_shoot_up_left:		.db #0x04, #0x08	;; Key_I
	hero_shoot_up_right:	.db #0x03, #0x08	;; Key_P
	hero_shoot_up:			.db #0x04, #0x04	;; Key_O

hero_input_joystick::
	hero_left_joystick:		.dw #0x0409
	hero_right_joystick:	.dw #0x0809
	hero_up_joystick:		.dw #0x0109
	hero_down_joystick:		.dw #0x0209
	hero_shoot_joystick:	.dw #0x1009

hero_key_a::
	hero_left_keyboard:		.db #0x04, #0x04	;; Key_O
	hero_right_keyboard:	.db #0x03, #0x08	;; Key_P
	hero_up_keyboard:		.dw #0x0808 		;; Key_Q
	hero_down_keyboard:		.db #0x08, #0x20	;; Key_A
	hero_shoot_keyboard:	.dw #0x8005			;; Key_Space

;; Equ input
	.equ	key_left_l,		0
	.equ	key_left_h, 	1
	.equ	key_right_l,	2
	.equ	key_right_h, 	3
	.equ	key_up_l, 		4
	.equ	key_up_h, 		5
	.equ	key_down_l, 	6
	.equ	key_down_h,		7
	.equ	key_shoot_l, 	8
	.equ	key_shoot_h,	9

teclas_para_joystick:	.dw hero_key_a

hit_box_variables:
	hit_box_x:				.db #0
	hit_box_y:				.db #125
	hit_box_w:				.db #80
	hit_box_h:				.db #10

hero_max_lifes:				.db #5

;; ================================================================================
;; ================================================================================
;; PUBLIC FUNCTIONS
;; ================================================================================
;; ================================================================================

;; ======================================================================
;; Cambia el tipo de teclas con las que se va a jugar en el joystick
;; MODIFICA: AF, BC, DE, HL
;; ======================================================================

change_keys_hero::
	cp #1
	jr z, poner_keyboard_teclas
	ld de, #hero_input_joystick

	jr cargar_cambio_teclas


	poner_keyboard_teclas:
	ld de, #hero_key_a

	cargar_cambio_teclas:
	ld hl, #teclas_para_joystick
	ld (hl), e
	inc hl
	ld (hl), d

	ret

;; ======================================================================
;; Update del heroe donde se hace una revision de los input
;; MODIFICA: AF, BC, DE, HL
;; ======================================================================
hero_update_joystick::

	call pause_detection
	call hero_update_animation

	ld iy, (teclas_para_joystick)

	ld	a,	(hero_shooting_cooldown)			;; We get the shooting cooldown
	cp #0										;; We check against 0 to see if it has ended
	jr	z, shoot_down_completed_joystick		;; If it has ended we do nothing
		dec	a									;; We decrement the shooting cooldown if it hasn't ended
		ld	(hero_shooting_cooldown), a			;; And then we save it
	shoot_down_completed_joystick:


	ld h, key_shoot_h(iy)
	ld l, key_shoot_l(iy)
	call cpct_isKeyPressed_asm
	cp #0x00
	jr nz, shoot_joystick

	;; ------------------------------------------X
	;; -------------------------------Right	
	ld e, #0						;; Reseteamos el valor de E para almacenar el valor del input
	ld h, key_right_h(iy)			;; Nos guardamos el valor de la tecla d en HL
	ld l, key_right_l(iy)
	call cpct_isKeyPressed_asm		;; Comprobamos si la D esta siendo pulsada
	cp #0x00
	jr z, try_move_left_joystick	;; ==0 | No se ha pulsado la tecla
	inc e							;; En el caso de que se haya pulsado incrementamos E
	
	try_move_left_joystick:
	;; -------------------------------Left
	ld h, key_left_h(iy)			;; Nos guardamos el valor de la tecla d en HL
	ld l, key_left_l(iy)
	call cpct_isKeyPressed_asm		;; Comprobamos si la A esta siendo pulsada
	cp #0x00
	jr z, save_movement_x_joystick	;; ==0 | No se ha pulsado la tecla
	dec e							;; En el caso de que se haya pulsado decrementamos E


	save_movement_x_joystick:
	ld a, e
	ld (hero_moving_x), a			;; Almacenamos el valor de E en la variable del input de X

	;; ------------------------------------------Y
	;; --------------------------------Up
	ld e, #0						;; Volvemos a resetear E para el input de Y
	ld h, key_up_h(iy)			;; Nos guardamos el valor de la tecla d en HL
	ld l, key_up_l(iy)
	call cpct_isKeyPressed_asm		;; Comprobamos si la W esta siendo pulsada
	cp #0x00
	jr z, try_move_down_joystick	;; ==0 | NO se ha pulsado la tecla
	ld a, e							;; En el caso de que se haya pulsado decrementamos E
	sub #4
	ld e, a

	try_move_down_joystick:
	;; --------------------------------Down
	ld h, key_down_h(iy)			;; Nos guardamos el valor de la tecla d en HL
	ld l, key_down_l(iy)
	call cpct_isKeyPressed_asm		;; Comprobamos si la S esta siendo pulsada
	cp #0x00
	jr z, save_movement_y_joystick	;; ==0 | No se ha pulsado la S
	ld a, e							;; En el caso de que se haya pulsado incrementamos E
	add a, #4
	ld e, a

	save_movement_y_joystick:
	ld a, e
	ld (hero_moving_y), a			;; Almacenamos el valor de E en la variable del input de Y
	
	call move_hero					;; Llamamos a la funcion de movimiento del heroe

	ret
	;; ------------------------------------------ OTHER
	
	shoot_joystick:
	
	ld h, key_left_h(iy)			;; Nos guardamos el valor de la tecla d en HL
	ld l, key_left_l(iy)
	call cpct_isKeyPressed_asm
	cp #0x00
	jr z, .+7
	ld b, #-1
	call hero_shoot

	ld h, key_right_h(iy)			;; Nos guardamos el valor de la tecla d en HL
	ld l, key_right_l(iy)
	call cpct_isKeyPressed_asm
	cp #0x00
	jr z, .+7
	ld b, #1
	call hero_shoot

	ld b, #0
	call hero_shoot

	ld	iy,	#hero_variables
	ld	hero_moving_x_index(iy), #0
	ld	hero_moving_y_index(iy), #0

	ret

;; ======================================================================
;; Update del sprite del heroe
;; MODIFICA: AF, BC, DE, HL
;; ======================================================================
hero_update_animation::

	ld		a, (hero_moving_x)
	cp		#0
	jr		nz, carga_siguiente_posicion_animacion
	
	ld		a, (hero_moving_y)
	cp		#0
	jr		z, cargar_posicion_0_animacion


	carga_siguiente_posicion_animacion:
	ld 		a, (hero_frame_anime)
	inc 	a
	ld 		(hero_frame_anime), a
	cp 		#4
	jr		nz, cargar_sprite_nuevo
	
	cargar_posicion_0_animacion:
	ld		a, #0
	ld 		(hero_frame_anime), a

	cargar_sprite_nuevo:
	call	load_new_sprite
	ret

;; ======================================================================
;; Update del heroe donde se hace una revision de los input
;; MODIFICA: AF, BC, DE, HL
;; ======================================================================
hero_update::

	call pause_detection
	call hero_update_animation

	ld	a,	(hero_shooting_cooldown)		;; We get the shooting cooldown
	cp #0									;; We check against 0 to see if it has ended
	jr	z, shoot_down_completed				;; If it has ended we do nothing
		dec	a									;; We decrement the shooting cooldown if it hasn't ended
		ld	(hero_shooting_cooldown), a			;; And then we save it
	shoot_down_completed:

	;; ------------------------------------------X
	;; -------------------------------Right	
	ld e, #0						;; Reseteamos el valor de E para almacenar el valor del input
	ld hl, (#hero_right)			;; Nos guardamos el valor de la tecla d en HL
	call cpct_isKeyPressed_asm		;; Comprobamos si la D esta siendo pulsada
	cp #0x00
	jr z, try_move_left				;; ==0 | No se ha pulsado la tecla
	inc e							;; En el caso de que se haya pulsado incrementamos E
	
	try_move_left:
	;; -------------------------------Left
	ld hl, (#hero_left)				;; Nos guardamos el valor de la tecla a en HL
	call cpct_isKeyPressed_asm		;; Comprobamos si la A esta siendo pulsada
	cp #0x00
	jr z, save_movement_x			;; ==0 | No se ha pulsado la tecla
	dec e							;; En el caso de que se haya pulsado decrementamos E


	save_movement_x:
	ld a, e
	ld (hero_moving_x), a			;; Almacenamos el valor de E en la variable del input de X

	;; ------------------------------------------Y
	;; --------------------------------Up
	ld e, #0						;; Volvemos a resetear E para el input de Y
	ld hl, (#hero_up)				;; Nos guardamos el valor de la tecla w en HL
	call cpct_isKeyPressed_asm		;; Comprobamos si la W esta siendo pulsada
	cp #0x00
	jr z, try_move_down				;; ==0 | NO se ha pulsado la tecla
	ld a, e							;; En el caso de que se haya pulsado decrementamos E
	sub #4
	ld e, a

	try_move_down:
	;; --------------------------------Down
	ld hl, (#hero_down)				;; Nos guardamos el valor de la tecla s en HL
	call cpct_isKeyPressed_asm		;; Comprobamos si la S esta siendo pulsada
	cp #0x00
	jr z, save_movement_y			;; ==0 | No se ha pulsado la S
	ld a, e							;; En el caso de que se haya pulsado incrementamos E
	add a, #4
	ld e, a

	save_movement_y:
	ld a, e
	ld (hero_moving_y), a			;; Almacenamos el valor de E en la variable del input de Y
	
	call move_hero					;; Llamamos a la funcion de movimiento del heroe

	;; ------------------------------------------ OTHER
	ld	hl, (#hero_shoot_up)
	call cpct_isKeyPressed_asm
	cp #0x00
	jr z, .+7
	ld b, #0
	call hero_shoot

	ld	hl, (#hero_shoot_up_left)
	call cpct_isKeyPressed_asm
	cp #0x00
	jr z, .+7
	ld b, #-1
	call hero_shoot

	ld	hl, (#hero_shoot_up_right)
	call cpct_isKeyPressed_asm
	cp #0x00
	jr z, .+7
	ld b, #1
	call hero_shoot
	ret

;; ======================================================================
;; Borra el heroe
;; MODIFICA: AF, BC, DE, HL
;; ======================================================================
hero_erase::
	ld ix, #hero_variables
	call erase_entity
	ret

;; ======================================================================
;; Inicializa el HEROE
;; MODIFICA: AF, BC, DE, HL
;; ======================================================================
hero_init::
	
	ld ix, #hero_variables
	ld hero_x_index(ix),					#48
	ld hero_y_index(ix),					#160
	ld hero_w_index(ix),					#4
	ld hero_h_index(ix),					#10
	
	ld	hl, #_pre_Frame1
	ld	hero_sprite_h_index(ix), h
	ld	hero_sprite_l_index(ix), l
	
	ld hero_shooting_cooldown_index(ix),	#15
	ld hero_moving_x_index(ix), 			#0
	ld hero_moving_y_index(ix), 			#0
	ld hero_points_centim(ix), 				#0
	ld hero_points_decim(ix), 				#0
	ld hero_points_index(ix), 				#0
	ld hero_lifes_index(ix), 				#3

	call redraw_lifes

	ld		a,	#0
	call	gui_change_points_1
	ld		a,	#0
	call	gui_change_points_2
	ld 		a,	#0
	call	gui_change_points_3

	ret

;; ======================================================================
;; Pinta el heroe
;; MODIFICA: AF, BC, DE, HL
;; ======================================================================
hero_draw::
	ld ix, #hero_variables
	call paint_entity
	ret

;; ======================================================================
;; ADd a point to the hero
;; MODIFICA: AF, BC, DE, HL
;; ======================================================================
hero_add_point::
	push	ix								;; We save the IX

	ld		ix,	#hero_variables				;;|
	ld 		a, hero_points_index(ix)
	inc		a								;;| We add a point
	ld		hero_points_index(ix), a
	cp 		#10
	jr 		nz, dontInitPoints				;; El numero del indice ha pasado el maximo
	ld		hero_points_index(ix), #0
	
	ld 		a, hero_points_decim(ix)
	inc		a
	ld		hero_points_decim(ix), a
	cp 		#10
	jr		nz, print_decim_Points				;; Las decimas han pasado el maximo e igualamos el contado a 0
	ld		hero_points_decim(ix), #0
	
	ld 		a, hero_points_centim(ix)
	inc 	a
	ld 		hero_points_centim(ix), a
	cp 		#10
	jr		nz, print_centim_Poins
	ld		hero_points_centim(ix), #0

	print_centim_Poins:
	ld a, hero_points_centim(ix)
	call gui_change_points_3

	print_decim_Points:
	ld a, hero_points_decim(ix)
	call gui_change_points_2

	dontInitPoints:
	ld a, hero_points_index(ix)
	call gui_change_points_1

	pop		ix								;; We reload the IX							;; We reload the IX
	ret

;; ======================================================================
;; Guardar las variables X Y antes del update
;; MDOFICA: A
;; ======================================================================
save_last_variables_hero::
	ld a, (hero_x)
	ld (hero_last_x), a

	ld a, (hero_y)
	ld (hero_last_y), a
	ret
;; ======================================================================
;; *Anyade una vida sin pasarse del maximo
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
add_life::
	ld		a,	(hero_max_lifes)	;;|
	ld		b,	a					;;| Cargamos en B el nuero maximo de vida

	ld		a,	(hero_lifes)		;;  Cargamos en A las vidas actuales

	cp		b						;;  Comparamos B y A
	ret 	z						;; 	En el caso de que sean iguales no incrementamos las vidas

	inc		a						;;|
	ld		(hero_lifes),	a		;;| Anyade una vida mas a las actuales

	push 	ix						;;  Almacenamos IX en la pila para no editarlo
	ld 		ix, #hero_variables
	call 	redraw_lifes			;;| ( IX / AF, BC, DE, HL / - )
									;;| Pintamos en la GUI las vidas actuales
	pop 	ix						;;  Recuperamos IX desde la pila
	ret
;; ================================================================================
;; ================================================================================
;; PRIVATE FUNCTIONS
;; ================================================================================
;; ================================================================================

;; ======================================================================
;; Carga en IX, el sprite correspondiente al numero pasado por A*2
;; ENTRADA: A, IX
;; MODIFICA: IX, A
;; ======================================================================

load_new_sprite:

	ld ix, #hero_variables

	ld h, -1(ix)
	ld l, -2(ix)

	ld b, #0
	ld a, (hero_frame_anime)
	ld c, a					;; LD BC -> A

	add hl, bc
	add hl, bc				;;HL = HL + A*2

	ld d, (hl)
	ld 6(ix), d				;; Cargar el sprite

	inc hl
	ld d, (hl)
	ld 7(ix), d
	
ret

;; ======================================================================
;; Disparo una bala
;; ENTRADA: B = X Shooting Dir
;; MODIFICA: A, IX
;; ======================================================================
hero_shoot:
	ld	a, (hero_shooting_cooldown)		;; | We check the cooldown
	cp	#0								;; | Check against 0
	jr	nz, cooldown_not_completed		;; | If cooldown not finished, then we don't shoot

		;; If cooldown has been completed we fire
		ld	ix,	#hero_variables			;; We set a pointer to the hero variables
		call change_sprite_direction
		call fire_bullet_hero			;; Direction is in B, from the hero_update

		ld	a, #10							;; |
		ld	(hero_shooting_cooldown), a		;; | We restore the shooting cooldown

	cooldown_not_completed:
	ret

; ======================================================================
;; Miro hacia donde disparo
;; ENTRADA: B = X Shooting Dir
;; ======================================================================
change_sprite_direction:
	ld	a,	b				;; B = A To check

	cp	#-1					;;|
	jr	z,	looking_left	;;| If Dir = 1, we look Left

	cp	#1					;;|
	jr	z,	looking_right	;;| If Dir = -1, we look Right

	;; If not, we're looking Up
	ld	hl, #hero_animation_up
	ld	hero_animation_h_index(ix), h
	ld	hero_animation_l_index(ix), l
	ret

	looking_left:
	ld	hl, #hero_animation_left
	ld	hero_animation_h_index(ix), h
	ld	hero_animation_l_index(ix), l
	ret

	looking_right:
	ld	hl, #hero_animation_right
	ld	hero_animation_h_index(ix), h
	ld	hero_animation_l_index(ix), l
	
	ret

;; ======================================================================
;; Inicializa el HEROE despeus de MORIR
;; ======================================================================
dec_life::

	call hero_death_anim

	ld		ix, #hero_variables
	ld		a,	hero_lifes_index(ix)	;; A = Lifes
	dec		a							;; We dec the life
	cp		#0							;; We check
	jr		nz,	nomuere					;; If we dont die we jump

	call	hero_die
	ret		z

	nomuere:							;; If we're not dead
	ld	(hero_lifes),	a				;; We save the bullets

	call init_clip						;; Quitar PUP
	call bullet_init_all				;; Init Bullets
	call barril_init_all				;; Init Barriles
	call enemy_init_all					;; Init Enemy
	call power_up_init					;; Init PUP
	call init_gui						;; Init GUI
	call pieza_desactivar


	;; Reinit the HERO
	ld	ix, #hero_variables
	ld	hero_x_index(ix),					#48
	ld	hero_y_index(ix),					#160
	ld	hl, #_pre_Frame1
	ld	hero_sprite_h_index(ix), h
	ld	hero_sprite_l_index(ix), l
	ld	hero_shooting_cooldown_index(ix),	#15
	ld	hero_moving_x_index(ix), 			#0
	ld	hero_moving_y_index(ix), 			#0
	ld 	hero_frame_anime_index(ix),	#0
	ld	hl, #hero_animation_up
	ld	hero_animation_h_index(ix), h
	ld	hero_animation_l_index(ix), l

	push ix
	ld ix, #hero_variables
	call redraw_lifes
	pop ix

	ret

;;; ======================================================================
;; Mueve al heroe en todas las direcciones
;; ENTRADA: -
;; MODIFICA: A, HL
;; ======================================================================

move_hero:
	;;---------------MOVING X
	ld a, (hero_x)			;; Guardo en A la posicion x del heroe
	ld hl, #hero_moving_x	
	add a, (hl)				;; Le sumo a la posicion el input de movimiento
	ld (hero_x), a			;; Almaceno el valor en la variable del personaje
	
	ld d, a						;; Y más adelante si colisiona se la restaremos
	;;--------------MOVING Y
	ld a, (hero_y)			;; Guardo en A la posicion y del heroe
	ld hl, #hero_moving_y
	add a, (hl)				;; Le sumo a la posicion el input de movimeno
	ld (hero_y), a
	ld e, a					;; Guardo en E el nuevo valor de Y

	;;---------------COLISIONES LATERALES
	ld a, d
	cp #19					;; Compruebo si con la suma se sale de la pantalla por la izquierda
	jr z, not_move_xy
	cp #77					;; Compruebo si con la suma se sale de la pantalla por la derecha
	jr z, not_move_xy

	
	call colisiones_hero		;; Extension del codigo (el ret de esta parte se encuentra alli)
		ld a, e
		cp #188					;; Compruebo si con la suma se sale de la panalla por abajo
		jr z, not_move_y
	ret

	move_all_less_y:
		call barril_update
		call enemy_move_vertical
		call power_up_update
		call pieza_update
	jr not_move_y


	not_move_xy:
		;; Volvemos a poner los datos iniciales porque ha habido una colision					
		ld a, (hero_x)
		ld hl, #hero_moving_x
		sub (hl)
		ld (hero_x), a
		jr not_move_y

	not_move_y:
		ld a, (hero_y)
		ld hl, #hero_moving_y
		sub (hl)
		ld (hero_y), a

	ret

;; ======================================================================
;; Colisiones del hero (EXTENSION MOVE_HERO / SIN RET)
;; ENTRADA: ix = #hero_variables, iy = #barril1_variables
;; MODIFICA: A, HL
;; ======================================================================

colisiones_hero:
	ld ix, #hero_variables


	ld iy, #barril1_variables
	call colisiones_hero_entity
	cp #0
	jr nz, not_move_xy

	ld iy, #barril2_variables
	call colisiones_hero_entity
	cp #0
	jr nz, not_move_xy

	ld iy, #enemy1_data
	call colisiones_hero_entity
	cp #0
	call nz, dec_life

	ld iy, #enemy2_data
	call colisiones_hero_entity
	cp #0
	call nz, dec_life

	ld iy, #enemy3_data
	call colisiones_hero_entity
	cp #0
	call nz, dec_life

	ld iy, #enemy4_data
	call colisiones_hero_entity
	cp #0
	call nz, dec_life

	ld iy, #enemy5_data
	call colisiones_hero_entity
	cp #0
	call nz, dec_life

	ld iy, #power_up_variables
	call colisiones_hero_entity
	cp #1
	call z, apply_power_up

	ld iy, #pieza1_variables
	call colisiones_hero_entity
	cp #1
	push af
	call z, pieza_pillada
	pop af
	jp z, not_move_xy

	ld iy, #hit_box_variables
	call colision_entidad_total
	cp #1
	jp z, move_all_less_y

	ret

;; ======================================================================
;; El heroe ha muerto
;; ENTRADA: ix = #hero_variables, iy = #barril1_variables
;; MODIFICA: A, HL
;; ======================================================================
hero_die:
	call change_dead
	ret

;; ======================================================================
;; El heroe ha muerto animacion
;; ENTRADA: ix = #hero_variables
;; ======================================================================
hero_death_anim:

	call play_player_death_sfx

	call enemy_draw
	call barril_draw
	call power_up_draw
	call pieza_draw
	ld hl, #0x0C10
	call cpct_setPALColour_asm
	ld 		ix, #hero_variables
	ld		hl, #_pre_FrameDeath0
	ld		hero_sprite_h_index(ix), h
	ld		hero_sprite_l_index(ix), l
	call	hero_draw
	ld 		ix, #hero_variables
	call	cambiar_inicio_pantalla
	call	bullet_erase_all
	call 	hero_erase
	call 	save_last_variables_hero

	ld	a,	#125
	call halt_loop
	ld hl, #0x1410
	call cpct_setPALColour_asm
	ld		hl, #_pre_FrameDeath1	
	ld 		ix, #hero_variables
	ld		hero_sprite_h_index(ix), h
	ld		hero_sprite_l_index(ix), l
	call	hero_draw
	call	cambiar_inicio_pantalla

	ld	a,	#125
	call halt_loop
	ld hl, #0x0C10
	call cpct_setPALColour_asm
	ld 		ix, #hero_variables
	ld		hl, #_pre_FrameDeath2
	ld		hero_sprite_h_index(ix), h
	ld		hero_sprite_l_index(ix), l	
	call	hero_draw
	call	cambiar_inicio_pantalla

	ld	a,	#125
	call halt_loop
	ld hl, #0x1410
	call cpct_setPALColour_asm
	ld 		ix, #hero_variables
	ld		hl, #_pre_FrameDeath3
	ld		hero_sprite_h_index(ix), h
	ld		hero_sprite_l_index(ix), l	
	call	hero_draw
	call	cambiar_inicio_pantalla

	ld	a,	#125
	call halt_loop
	ld hl, #0x0C10
	call cpct_setPALColour_asm
	call	hero_erase
	call	cambiar_inicio_pantalla	

	ld	a,	#125
	call halt_loop
	ld hl, #0x1410
	call cpct_setPALColour_asm
	call	doErasing
	call 	save_all_last_variables
	call 	doErasing


	ld	a,	#125
	call halt_loop

	ld	de,	#_song_sfx
	call init_sfx


ret

;; ======================================================================
;; Comprueba las colisiones del heroe con los barriles
;; ENTRADA: ix = #hero_variables, iy = #barril1_variables
;; MODIFICA: A, HL
;; ======================================================================
colisiones_hero_entity:


	call load_new_sprite

	call colision_entidad_total		;; Colision_Horizontal (A = 0 si hay colision)
	cp #0							;; Si A = 0, hay colision asi que Volvemos
	ld a, #0						;;|
	ret z							;;| Devolvemos FALSE
			
	ld a, #1						;; Devolvemos TRUE
	ret p							;; En el caso de que sea positivo es que esta por encima o el lado				

	ret