
;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of ProtonSmoke: An Amstrad CPC Shoot 'Em Up Game
;; Copyright (C) 2017 Daniel Finestrat Martinez (@DanielFinestrat)
;; Copyright (C) 2017 Angel Navarro Martinez (@EingelNavarro)
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.area _CODE

.include "cpctelera.h.s"
.include "menu.h.s"
.include "hero.h.s"
.include "assets.h.s"
.include "sfx.h.s"

.globl _cpct_keyboardStatusBuffer

;; =====================================================================================================================||
;; =====================================================================================================================||
;; PUBLIC FUNCTIONS
;; =====================================================================================================================||
;; =====================================================================================================================||

;; ======================================================================
;; *Espera de input en el main del juego
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: A
;; ======================================================================
wait_input_menu::
	call 	cpct_scanKeyboard_asm				;;| ( - / AF, BC, DE, HL / - )
												;;| Escaneamos el teclado 

	ld 		hl, #0x0406							;;|
	call	cpct_isKeyPressed_asm				;;| ( HL / A, BC, D, HL / A )
	cp		#0x00								;;|
	ld 		a, #0								;;| Cargamos en A el valor de salida
	jr		nz, wait_input_menu_acabado			;;| Comprobamos si R esta siendo pulsado


	ld		hl, #0x2004							;;| 
	call 	cpct_isKeyPressed_asm				;;| ( HL / A, BC, D, HL / A )
	cp 		#0x00								;;|
	ld		a, #1								;;|	Cargamos en A el valor de salida
	jr		nz, wait_input_menu_acabado			;;|	Comprobamos si K esta siendo pulsada


	ld		hl, #0x4006							;;|
	call	cpct_isKeyPressed_asm				;;| ( HL / A, BC, D, HL / A )
	cp		#0x00								;;|
	ld		a, #2								;;| Cargamos en A el valor de salida
	jr		nz, wait_input_menu_acabado			;;| Comprobamos si B esta siendo pulsada


	ld		hl, #0x2005							;;|
	call	cpct_isKeyPressed_asm				;;| ( HL / A, BC, D, HL / A )
	cp		#0x00								;;| 
	ld		a, #3								;;| Cargamos en A el valor de salida
	jr		nz, wait_input_menu_acabado			;;| Comprobamos si J esta siendo pulsada
	;; -----------------------------------------	
	;; Tecla no pulsada
	;; -----------------------------------------	
	jr 		wait_input_menu						;;  Volvemos al inicio del bucle

	wait_input_menu_acabado:
	;; -----------------------------------------	
	;; Tecla pulsada
	;; -----------------------------------------	
	push af										;;  Guardamos en la pila el valor de salidas
	call bucle_esperar_soltar_tecla				;;| ( - / AF, BC, DE, HL / - )
												;;| Esperamos a que se suelte la tecla que se ha pulsado
	call	play_menu_sfx						;; Hacemos sonar el SFX del menu
	pop af										;;  Volvemos a cargar en A el valor de salida 

	ret
;; ======================================================================
;; *Espera de input en el main del juego
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
wait_for_enter::
	call 	cpct_scanKeyboard_asm				;;| ( - / AF, BC, DE, HL / - )
												;;| Escaneamos el teclado 

	ld 		hl,	#0x0402							;;| Nos guardamos el valor de la tecla ENTER en HL
	call	cpct_isKeyPressed_asm				;;| ( HL / A, BC, D, HL / A )
	cp		#0x00								;;|
	jr		nz,	wait_for_enter_acabado			;;| Comprobamos si se pulsado el ENTER
	;; -----------------------------------------	
	;; ENTER no pulsado
	;; -----------------------------------------		
	jr 		wait_for_enter						;;  Volvemos a hacer el bucle

	wait_for_enter_acabado:
	;; -----------------------------------------	
	;; ENTER pulsado
	;; -----------------------------------------	
	call 	bucle_esperar_soltar_tecla			;;| ( - / AF, BC, DE, HL / - )
												;;| Esperamos a que se suelte el ENTER
	ret
;; ======================================================================
;; *Bucle de pause que se ejecuta mientras que no se pulse el ENTER
;; Mientras que este el bucle la paleta ira cambiando
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
wait_for_enter_pause::

	call play_pause_sfx

	wait_for_enter_pause_1:	
	;; -----------------------------------------	
	;; Inicio del bucle
	;; -----------------------------------------
	call cpct_scanKeyboard_asm					;;| ( - / AF, BC, DE, HL / - )
												;;| Escaneamos el teclado 

	ld 		hl,	#0x0402							;;| Nos guardamos el valor de la tecla ENTER en HL
	call	cpct_isKeyPressed_asm				;;| ( HL / A, BC, D, HL / A )
	cp		#0x00								;;| 
	jr		nz,	wait_for_enter_acabado_pause	;;| Comprobamos si ENTER se esta pulsando
	;; -----------------------------------------	
	;; El ENTER no ha sido pulsado
	;; -----------------------------------------	
	espera_cambiar_paleta_l = .+1				;;|
	ld 		l,  #0xFF							;;|
	espera_cambiar_paleta_h = .+1				;;|
	ld 		h, #0xFF							;;| Carga en HL del contador del bucle para cambiar paleta

	dec 	hl									;;|
	push 	hl									;;| Decrementamos el contador y lo guardamos en la pila

	ld 		d, h								;;|
	ld 		e, l								;;| Pasamos el contador de HL a DE
	ld 		hl, #espera_cambiar_paleta_l		;;| 
	ld 		(hl), e								;;| Cargamos la primera variable
	ld 		hl, #espera_cambiar_paleta_h		;;|
	ld 		(hl), d								;;| Cargamos la segunda variables
												;;| Almacenamos el contador de vuelta en sus variables para la siguiente iteracion

	pop 	hl									;;  Volvemos a cargar el contador en hl

	ld 		a, h								;;|
	add 	a, l								;;| H + L = 0
	jr 		nz, wait_for_enter_pause_1			;;| Comparamos si el contador ha llegado a 0 y hay que cambiar la paleta
	;; -----------------------------------------	
	;; El contador hay llegado a 0
	;; -----------------------------------------	
	call 	actualizar_valores_pause			;;| ( - / HL / - )
												;;| Actualiza las variables del contador

	veces_a_repetir_pause = .+1					;;|
	ld 		a, #0x09							;;| Cargamos en A el segundo contador
	dec 	a									;;|
	ld 		(veces_a_repetir_pause), a			;;| Decrementamos el contador y lo volvemos a guardar en la variable

	jr		nz,	wait_for_enter_pause_1			;;  Comprobamos si el contador ha llegado a 0
	;; -----------------------------------------	
	;; El contador hay llegado a 0
	;; -----------------------------------------	
	ld 		hl, #veces_a_repetir_pause			;;|
	ld 		(hl), #0X09							;;| Cargamos en el segundo contador el valor inicial

	paleta_para_cambiar = .+1					;;|
	ld		a,	#00								;;| Cargamos en A la paleta que vamos a utilizar
	cp		#0									;;|
	jp 		z, change_first_palette				;;| A == 0 
	jp 		change_second_palette				;;| A == 1

	acabar_el_bucle:
	ld 		a, (paleta_para_cambiar)			;;|
	xor 	#1									;;| Cambiamos la paleta que vamos a uilizar
	ld 		(paleta_para_cambiar), a			;;| Guardamos en la variable el nuevo valor

	jp 		wait_for_enter_pause_1				;;  Volvemos al inicio del bucle de pausa

	wait_for_enter_acabado_pause:
	;; -----------------------------------------	
	;; El ENTER se ha pulsado
	;; -----------------------------------------	
	call	bucle_esperar_soltar_tecla			;;| ( - / AF, BC, DE, HL / - )
												;;| Esperamos a que se suelta la tecla 

	ld 		hl, #_pre_palette					;;|
	ld 		de, #16								;;|
	call 	cpct_setPalette_asm					;;| ( DE, HL / AF, BC, DE, HL / - )
												;;| Cambiamos la paleta del juego a la que tenia originalmene
	ret
;; ======================================================================
;; *Cargado de teclas en las variables del jugador
;; ENTRADA: IX, IY
;; MODIFICA: HL, AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
cargar_teclas::

	ld 		a, #60							;;| Cargamos el numero de halts a hacer
	call 	halt_loop						;;| ( A / A / - )
											;;|	Hacemos una pequeña espera antes de empezar a captar teclas

	ld 		iy, #hero_key_a					;;  Cargamos en IY un puntero a las teclas del modo retro (key_A)		

	;;; -----------------------------------------
	;; Tecla Izquieda
	;; -----------------------------------------
	call 	menu_draw_left					;;| ( - / AF, BC, DE, HL /  - )
											;;| Pintamos el texto de LEFT

	call 	esperar_tecla_keyboard			;;| ( - / HL, A, BC, DE / BC )
											;;| Esperamos a que se pulse una tecla y la almacenamos en BC

	ld 		0(ix), c						;;|
	ld 		1(ix), b						;;|
	ld 		0(iy), c						;;|
	ld 		1(iy), b						;;| Almacenamos en las variables la tecla que hemos captado

	call 	bucle_esperar_soltar_tecla 		;;| ( - / AF, BC, DE, HL / - )
											;;| Esperamos a que se suelte el ENTER


	call	play_menu_sfx					;; Hacemos sonar el SFX del menu

	;; -----------------------------------------
	;; Tecla Derecha
	;; -----------------------------------------
	call 	menu_draw_right					;;| ( - / AF, BC, DE, HL / - )
											;;| Pintamos el texto de RIGTH

	call 	esperar_tecla_keyboard			;;| ( - / HL, A, BC, DE / BC )
											;;| Esperamos a que se pulse una tecla y la almacenamos en BC

	ld 		2(ix), c						;;|
	ld 		3(ix), b						;;|
	ld 		2(iy), c						;;|
	ld 		3(iy), b						;;|	Almacenamos en las variables la tecla que hemos captado

	call 	bucle_esperar_soltar_tecla		;;| ( - / AF, BC, DE, HL / - )
											;;| Esperamos a que se suelte el ENTER

	call	play_menu_sfx					;; Hacemos sonar el SFX del menu

	;; -----------------------------------------
	;; Tecla Arriba
	;; -----------------------------------------
	call 	menu_draw_up					;;| ( - / AF, BC, DE, HL / - )
											;;| Pintamos el texto de UP

	call 	esperar_tecla_keyboard			;;| ( - / HL, A, BC, DE / BC )
											;;| Esperamos a que se pulse una tecla y la almacenamos en BC
											
	ld 		4(ix), c						;;|
	ld 		5(ix), b						;;|
	ld 		4(iy), c						;;|
	ld 		5(iy), b						;;| Almacenamos en las variables la tecla que hemos captado

	call 	bucle_esperar_soltar_tecla		;;| ( - / AF, BC, DE, HL / - )
											;;| Esperamos a que se suelte el ENTER

	call	play_menu_sfx					;; Hacemos sonar el SFX del menu

	;; -----------------------------------------
	;; Tecla Abajo
	;; -----------------------------------------
	call 	menu_draw_down					;;| ( - / AF, BC, DE, HL / - )
											;;| Pintamos el texto de DOWN

	call 	esperar_tecla_keyboard			;;| ( - / HL, A, BC, DE / BC )
											;;| Esperamos a que se pulse una tecla y la almacenamos en BC
											
	ld 		6(ix), c						;;|
	ld 		7(ix), b						;;|
	ld 		6(iy), c						;;|
	ld 		7(iy), b						;;| Almacenamos en las variables la tecla que hemos captado

	call 	bucle_esperar_soltar_tecla		;;| ( - / AF, BC, DE, HL / - )
											;;| Esperamos a que se suelte el ENTER

	call	play_menu_sfx					;; Hacemos sonar el SFX del menu

	;; -----------------------------------------
	;; Tecla Shoot Izq
	;; -----------------------------------------
	call menu_draw_shoot_left				;;| ( - / AF, BC, DE, HL / - )
											;;| Pintamos el texto de Shoot Left

	call 	esperar_tecla_keyboard			;;| ( - / HL, A, BC, DE / BC )
											;;| Esperamos a que se pulse una tecla y la almacenamos en BC
											
	ld 		8(ix), c						;;| 
	ld 		9(ix), b						;;| Almacenamos en las variables la tecla que hemos captado

	call 	bucle_esperar_soltar_tecla		;;| ( - / AF, BC, DE, HL / - )
											;;| Esperamos a que se suelte el ENTER

	call	play_menu_sfx					;; Hacemos sonar el SFX del menu
	
	;; -----------------------------------------
	;; Tecla Shoot Der
	;; -----------------------------------------
	call menu_draw_shoot_right
	call 	esperar_tecla_keyboard			;;| ( - / HL, A, BC, DE / BC )
											;;| Esperamos a que se pulse una tecla y la almacenamos en BC
											
	ld 		10(ix), c						;;|
	ld 		11(ix), b						;;| Almacenamos en las variables la tecla que hemos captado

	call 	bucle_esperar_soltar_tecla		;;| ( - / AF, BC, DE, HL / - )
											;;| Esperamos a que se suelte el ENTER

	call	play_menu_sfx					;; Hacemos sonar el SFX del menu

	;; -----------------------------------------
	;; Tecla Shoot Up
	;; -----------------------------------------
	call menu_draw_shoot_up
	call 	esperar_tecla_keyboard			;;| ( - / HL, A, BC, DE / BC )
											;;| Esperamos a que se pulse una tecla y la almacenamos en BC
											
	ld 		12(ix), c						;;|
	ld 		13(ix), b						;;|
	ld 		8(iy), c						;;|
	ld 		9(iy), b						;;| Almacenamos en las variables la tecla que hemos captado

	call 	bucle_esperar_soltar_tecla		;;| ( - / AF, BC, DE, HL / - )
											;;| Esperamos a que se suelte el ENTER

	call	play_menu_sfx					;; Hacemos sonar el SFX del menu

	ret
;; ======================================================================
;; *Espera a que se pulsa una tecla y la devuelve
;; ENTRADA: --
;; MODIFICA: HL, A, BC, DE
;; SALIDA: BC
;; ======================================================================
esperar_tecla_keyboard::
	;; ----------------------------------------------------------------------------
	;; Bucle se queda en espera hasta que se pulsa alguna tecla del teclado
	;; ----------------------------------------------------------------------------
	call bucle_esperar_tecla_keyboard		
	;; -----------------------------------------
	;; Reconocer que tecla se ha pulsado
	;; -----------------------------------------	
	ld hl, #_cpct_keyboardStatusBuffer	;; Cargamos en hl la primera posicion del array de teclas
	ld b, #0							;; Reseteamos el valor de B para formar bien la combinacion BC
	ld c, #9							;; Sumamos 9 a C, debido a que el buffer de teclas tiene 10 posiciones
	add hl, bc							;; Movemos el array a la ultima posicion de este

	ld e, #10
	bucle_leer_tecla:					;; ( DATOS IMPORTANTES:::  HL - Posicion de memoria / E - Contador bucle)
		ld a, (hl)						;; Nos guardamos en A el byte que hay en HL
		ld b, #0xFF						;; Almacenamos en B un byte lleno de 1 para la funcion xor
		xor b							;; Revertimos el byte que habia en A
		cp #0x00						;; Comprobamos si algun bit estaba a 1
		jr z, siguiente_byte_teclas		;; Si es igual a 0 significa que este byte esta todo a 0 y saltamos al final del bucle
	;; ----------------------------------------------
	;; Almaceno en BC la tecla que se pulsado
	;; ----------------------------------------------
			ld b, a						;; Almaceno en B el valor de la tecla pulsada						
			dec e						;; Decremento bien para que se almacene el valor correspondiente
			ld c, e						;; Almaceno E en B
			ret							;; Devuelve BC
	;; ----------------------------------------------
	;; Contador del bucle que decrementa HL y E
	;; ----------------------------------------------
		siguiente_byte_teclas:
		dec hl
		dec e
	jr nz, bucle_leer_tecla
	ret
;; ======================================================================
;; *Wait for A loops
;; ENTRADA: A
;; MODIFICA: A
;; SALIDA: --
;; ======================================================================
halt_loop::
	halt					;;| Pequena espera
	dec	a					;;| Decrementamos A
	cp	#0					;;|
	jr	nz,	halt_loop		;;| En el caso de que (A!=0) volvemos a hacer el bucle
	ret

;; =====================================================================================================================||
;; =====================================================================================================================||
;; PRIVATE FUNCTIONS
;; =====================================================================================================================||
;; =====================================================================================================================||

;; ======================================================================
;; *Cambia la paleta del juego a la 1
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
change_first_palette:
	call cpct_waitVSYNC_asm		;;| ( - / AF, BC / - )
								;;| Nos esperamos a que el raster llegue abajo para que se actualice a la vez la paleta

	ld hl, #_pre_palette_1		;;| Nos guardamos la paleta a utilizar 
	ld de, #16					;;| Nos guardamos los colores a actualizar
	call cpct_setPalette_asm 	;;| ( DE, HL / AF, BC, DE, HL / - )
								;;| Actualizamos la paleta a utilizar
	jp acabar_el_bucle
;; ======================================================================
;; *Cambia la paleta del juego a la principal
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
change_second_palette:
	call cpct_waitVSYNC_asm		;;| ( - / AF, BC / - )
								;;| Nos esperamos a que el raster llegue abajo para que se actualice a la vez la paleta

	ld hl, #_pre_palette		;;| Nos guardamos la paleta a utilizar 
	ld de, #16					;;| Nos guardamos los colores a actualizar
	call cpct_setPalette_asm 	;;| ( DE, HL / AF, BC, DE, HL / - )
								;;| Actualizamos la paleta a utilizar
	jp acabar_el_bucle
;; ======================================================================
;; *Actualiza las variables del bucle para cambiar la paleta en pausa
;; ENTRADA: --
;; MODIFICA: HL
;; SALIDA: --
;; ======================================================================
actualizar_valores_pause:
	ld hl, #espera_cambiar_paleta_l		
	ld (hl), #0xFF						;; Carga en la primera variable del bucle #0xFF
	ld hl, #espera_cambiar_paleta_h		
	ld (hl), #0xFF						;; Carga en la segunda variable del bucle #0xFF
	ret
;; ======================================================================
;; *Bucle de espera hasta que se pulse alguna tecla
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
bucle_esperar_tecla_keyboard:
	call cpct_scanKeyboard_asm					;;| ( - / AF, BC, DE, HL / - )
												;;| Escaneamos el teclado 
	
	call cpct_isAnyKeyPressed_asm				;;| ( - / A, B, HL / A )
	cp #0x00									;;|
	jr z, bucle_esperar_tecla_keyboard			;;| Comprobamos si hay alguna tecla pulsandose
	;; -----------------------------------------	
	;; Alguna tecla pulsandose
	;; -----------------------------------------	
	ret
;; ======================================================================
;; *Bucle de espera. Se sale del bucle al no haber ninguna tecla pulsandose
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
bucle_esperar_soltar_tecla::
	call cpct_scanKeyboard_asm			;;| ( - / AF, BC, DE, HL / - )
										;;| Escaneamos el teclado 

	call cpct_isAnyKeyPressed_asm		;;| ( - / A, B, HL / A )
	cp #0x00							;;|
	jr nz, bucle_esperar_soltar_tecla	;;| Comprobamos si hay alguna tecla pulsandose
	;; -----------------------------------------	
	;; Ninguna tecla pulsada
	;; -----------------------------------------	
	ret
