
;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of ProtonSmoke: An Amstrad CPC Shoot 'Em Up Game
;; Copyright (C) 2017 Daniel Finestrat Martinez (@DanielFinestrat)
;; Copyright (C) 2017 Angel Navarro Martinez (@EingelNavarro)
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

;; Enemy Macro
	.macro defineEnemy name, x, y, w, h, active, spr, bllt
			name'_anim_index:	.db #0					;;-3		-- Animation step
			name'_sprite_dir:	.dw #enemy_animation	;; -1, -2	-- Anim Pointer
		name'_data::
			name'_x:			.db	x				;; 0 -- Origin X Position
			name'_y:			.db	y				;; 1 -- Origin Y Position

			name'_w:			.db	w				;; 2 -- Width of New Bullet (Bytes)
			name'_h:			.db	h				;; 3 -- Height of New Bullet (Pixels)

			name'_last_x:		.db #50				;; 4 -- (Hace un borrado en el primer buffer)
			name'_last_y:		.db #0				;; 5

			name'_sprite:		.dw spr				;; 6 & 7 -- Sprite of New Bullet
			name'_type:			.db #1				;; 8

			name'_dir_x:		.db	#0				;; 9 -- Moving direction on X Axis (-1, 0, 1)
			name'_dir_y:		.db	active			;; 10 -- Moving direction on X Axis (-1, 0, 1) --> 0 = Inactive

			name'_last_dir_y:	.db active			;; 11

			name'_life:			.db	#2				;; 12 -- Life meter of the enemy (Starting at 2)

			name'_bullet:		.dw	#bllt			;; 13 & 14

			name'_target:		.db #0				;; 15
			name'_n_target:		.db #0				;; 16
	.endm

;; Macro Enemy to IX Index
	.equ	enemy_x,			0
	.equ	enemy_y,			1
	.equ	enemy_w,			2
	.equ	enemy_h,			3
	.equ	enemy_last_x,		4
	.equ	enemy_last_y,		5
	.equ	enemy_sprite_l,		6
	.equ	enemy_sprite_h,		7
	.equ	enemy_type,			8
	.equ	enemy_dir_x,		9
	.equ	enemy_dir_y,		10
	.equ	enemy_last_dir_y, 	11
	.equ	enemy_life,			12
	.equ	enemy_bullet_l,		13
	.equ	enemy_bullet_h,		14
	.equ	enemy_target,		15
	.equ	enemy_n_target,		16
	.equ	enemy_anim_index,		-3
	.equ	enemy_anim_pointer_l,	-2
	.equ	enemy_anim_pointer_h,	-1

;; Macro Hero to IX Index
	.equ    hero_animation_l_index,			-2
	.equ	hero_animation_h_index, 		-1
	.equ	hero_x_index,					0
	.equ	hero_y_index,					1
	.equ	hero_w_index,					2
	.equ	hero_h_index,					3
	.equ 	hero_last_x_index,				4
	.equ	hero_last_y_index,				5
	.equ	hero_sprite_l_index,			6
	.equ	hero_sprite_h_index,			7
	.equ	hero_shooting_cooldown_index,	8
	.equ	hero_moving_x_index,			9
	.equ	hero_moving_y_index,			10
	.equ	hero_points_centim,				11
	.equ	hero_points_decim,				12
	.equ	hero_points_index,				13
	.equ	hero_lifes_index,				14		;;	CAUTION - En menu.s esta el valor a mano
	.equ    hero_frame_anime_index,			15

;; Barril Macro
	.macro crearBarril, name, x, y, w, h, sprite, type
		name'_variables::
			name'_x: 		.db x				;; 0 -- X pos of Barril
			name'_y: 		.db y				;; 1 -- Y pos of Barril

			name'_w: 		.db w				;; 2 -- Width of Barril
			name'_h: 		.db h				;; 3 -- Height of Barril

			name'_last_x:	.db x
			name'_last_y:	.db y

			name'_sprite: 	.dw  #_pre_roca		;; 4 & 5 -- Sprite of Barril

			name'_type:		.db type			;; 6 -- Type of Barril (0 = Non existing)
	.endm

;; Macro Barril to IX Index
	.equ	barril_x,			0
	.equ	barril_y,			1
	.equ	barril_w,			2
	.equ	barril_h,			3
	.equ	barril_last_x,		4
	.equ	barril_last_y,		5
	.equ	barril_sprite_l,	6
	.equ	barril_sprite_h,	7
	.equ	barril_type,		8

;; Bullet Macro
	.macro defineBullet name, x, y, w, h, spr, dmg
		name'_data::
			name'_x:				.db	x		;; 0 -- Origin X Position
			name'_y:				.db	y		;; 1 -- Origin Y Position

			name'_w:				.db	w		;; 2 -- Width of New Bullet (Bytes)
			name'_h:				.db	h		;; 3 -- Height of New Bullet (Pixels)
			name'_last_x:			.db x		;; 4
			name'_last_y:			.db y		;; 5

			name'_sprite:			.dw spr		;; 6 & 5 -- Sprite of New Bullet

			name'_dir_x:			.db	#0		;; 8 -- Moving direction on X Axis (-1, 0, 1)
			name'_dir_y:			.db	#0		;; 9 -- Moving direction on X Axis (-1, 0, 1) --> 0 = Inactive
			name'_last_dir_y: 		.db #0		;; 10

			name'_damage:			.db	dmg		;; 11 -- Damage Meter
			name'_distance:			.db #0		;; 12 -- Max Dist

			name'_death_cooldown:	.db #0		;; 13 -- Cooldown to reapear (so it always erases well)
	.endm

;; Macro to IX Index
	.equ	bullet_x,				0
	.equ	bullet_y,				1
	.equ	bullet_w,				2
	.equ	bullet_h,				3
	.equ	bullet_last_x,			4
	.equ	bullet_last_y,			5
	.equ	bullet_sprite_l,		6
	.equ	bullet_sprite_h,		7
	.equ	bullet_dir_x,			8
	.equ	bullet_dir_y,			9
	.equ	bullet_last_dir_y,		10
	.equ	bullet_damage,			11
	.equ	bullet_dist,			12
	.equ	bullet_death_cooldown,	13

;; Wrench Macro
	.macro crearPieza, name, x, y, w, h, sprite, isEnabled
		name'_variables::
			name'_x: 			.db x				;; 0 -- X pos of pup
			name'_y: 			.db y				;; 1 -- Y pos of pup

			name'_w: 			.db w				;; 2 -- Width of pup
			name'_h: 			.db h				;; 3 -- Height of pup

			name'_last_x:		.db x				;; 4
			name'_last_y:		.db y				;; 5

			name'_sprite: 		.dw  #sprite		;; 6 & 7 -- Sprite of Power Up

			name'_enabled:		.db isEnabled		;; 8 -- Is PUP Enabled
			name'_aparition:	.db #0
	.endm

;; Macro Wrench to IX Index
	.equ	pieza_x,			0
	.equ	pieza_y,			1
	.equ	pieza_w,			2
	.equ	pieza_h,			3
	.equ	pieza_last_x,		4
	.equ	pieza_last_y,		5
	.equ	pieza_sprite_l,		6
	.equ	pieza_sprite_h,		7
	.equ	pieza_enabled,		8
	.equ	pieza_aparition, 	9

;; pup Macro
	.macro crearPowerUp, name, x, y, w, h, sprite, isEnabled
		name'_variables::
			name'_x: 			.db x				;; 0 -- X pos of pup
			name'_y: 			.db y				;; 1 -- Y pos of pup

			name'_w: 			.db w				;; 2 -- Width of pup
			name'_h: 			.db h				;; 3 -- Height of pup

			name'_last_x:		.db x				;; 4
			name'_last_y:		.db y				;; 5

			name'_sprite: 		.dw  #sprite		;; 6 & 7 -- Sprite of Power Up

			name'_enabled:		.db isEnabled		;; 8 -- Is PUP Enabled

			name'_anim_index:	.db #0				;; 9 -- Animation step
			name'_sprite_dir:	.dw #pup_animation	;; 10 -- Anim Pointer
	.endm

;; Macro PowerUp to IX Index
	.equ	pup_x,				 0
	.equ	pup_y,				 1
	.equ	pup_w,				 2
	.equ	pup_h,				 3
	.equ	pup_last_x,			 4
	.equ	pup_last_y,			 5
	.equ	pup_sprite_l,		 6
	.equ	pup_sprite_h,		 7
	.equ	pup_enabled,		 8
	.equ	pup_anim_index,		 9
	.equ	pup_anim_pointer_l,	10
	.equ	pup_anim_pointer_h,	11

;; Macro TextPause 
	.macro createpauseentity name x y w h sprite
		name'_variables:
			name'_x: 		.db x
			name'_y: 		.db y
			name'_w: 		.db w
			name'_h: 		.db h
			name'_last_x:	.db #0x00
			name'_last_y:	.db y
			name'_sprite: 	.dw #sprite
	.endm

;; Macro Entity to IX Index
	.equ ent_x, 		0
	.equ ent_y, 		1
	.equ ent_width, 	2
	.equ ent_height, 	3
	.equ ent_last_x,	4
	.equ ent_last_y,	5
	.equ ent_l,	 		6
	.equ ent_h, 		7

;; BLOQUE_MACRO
	.macro createBloque name x y w h c
		name'_variables:
			name'_x: .db x
			name'_y: .db y
			name'_w: .db w
			name'_h: .db h
			name'_c: .db c
		.endm
	
;; NUMBER_MACRO
	.macro createNumber name x y w h sprite
		name'_variables:
			name'_x: 		.db x
			name'_y: 		.db y
			name'_w: 		.db w
			name'_h: 		.db h
			name'_last_x:	.db #0xC0
			name'_last_y:	.db y
			name'_sprite: 	.dw #sprite
		.endm

;; KEY_MACRO
	.macro createKey name x y w h sprite
		name'_variables:
			name'_x: 		.db x
			name'_y: 		.db y
			name'_w: 		.db w
			name'_h: 		.db h
			name'_last_x:	.db #0x00
			name'_last_y:	.db y
			name'_sprite:	.dw #sprite
		.endm

;; TITLE_MACRO
	.macro createTitle name x y w h sprite
		name'_variables:
			name'_x: 		.db x
			name'_y: 		.db y
			name'_w: 		.db w
			name'_h: 		.db h
			name'_last_x:	.db #0x00
			name'_last_y:	.db y
			name'_sprite:	.dw #sprite
		.endm
