
;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of ProtonSmoke: An Amstrad CPC Shoot 'Em Up Game
;; Copyright (C) 2017 Daniel Finestrat Martinez (@DanielFinestrat)
;; Copyright (C) 2017 Angel Navarro Martinez (@EingelNavarro)
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.area _CODE

.include "cpctelera.h.s"
.include "functions.h.s"
.include "assets.h.s"
.include "macros.h.s"

.globl change_music_speed

;; Number_Name to Sprite_Name
number_variables:
	number_10:	.dw		#_pre_10
	number_1:	.dw		#_pre_1
	number_2:	.dw		#_pre_2
	number_3:	.dw     #_pre_3
	number_4:	.dw     #_pre_4
	number_5:	.dw     #_pre_5
	number_6:	.dw     #_pre_6
	number_7:	.dw     #_pre_7
	number_8:	.dw     #_pre_8
	number_9:	.dw     #_pre_9


;; NUMEROS
createNumber number3 #2		#8		#4		#16		#_pre_10
createNumber number2 #8		#8		#4		#16		#_pre_10
createNumber number1 #14	#8		#4		#16		#_pre_10

;; MENU INICAL
createBloque bloque1 #0 	#0 		#10 	#200 	#0xFF
createBloque bloque2 #70 	#0		#10		#200	#0xFF
createBloque bloque3 #10	#170	#60		#30		#0xFF
createBloque bloque4 #10	#0		#60		#30		#0xFF

createKey cajawin 	#0			#115		#20		#24		#0xFF
createKey cajawin2 	#80-20		#115		#20		#24		#0xFF

;; KEYS
createKey up_k		#35		#70		#9		#24		#_pre_up
createKey down_k 	#30		#70		#19		#24		#_pre_down
createKey left_k 	#30		#70		#19		#24		#_pre_left
createKey right_k 	#28		#70		#23		#24		#_pre_right
createKey shoot_k 	#28		#75		#23		#24		#_pre_shoot

;; TITLE
createTitle title		#10		#0		#60		#26		#_pre_title
createTitle menu		#10		#60		#60		#90		#_pre_menu
createnumber twitter 	#17		#182	#47		#18		#_pre_twitter

createTitle return	#28		#160	#24		#6		#_pre_return	
createTitle death	#24		#40		#32		#12		#_pre_death
createTitle win 	#26		#40		#29		#12		#_pre_win
createTitle points 	#18		#80		#27		#12		#_pre_points

;; GUI JUEGO
createBloque bloque5 	#0		#0		#20		#200	#0x33
createNumber numLv   	#13		#78		#4		#16		#_pre_1
createNumber textoLV 	#3		#86		#8		#8		#_pre_nivel

createNumber textoC	 	#0		#33		#20		#14		#_pre_Protones
createBloque bloque6 	#0		#45		#20		#28		#0xC0
createnumber bala1   	#0		#50		#2		#8		#_sprite_Bullet_Hero_2

createNumber textoV	 	#0		#103	#20		#16		#_pre_life_tag
createBloque bloque7 	#0		#117	#20		#23		#0xC0
createnumber vida1   	#0		#122	#4		#10		#_pre_life

createnumber guititle 	#4		#145	#12		#10		#_pre_guititle

;;
;; SPACESHIP GUI
createBloque bloque8 	#0		#170		#20		#24		#0xC0

createnumber ship1 		#9		#170+19		#7		#5		#_pre_Ship1
createnumber ship2 		#4		#170+6		#12		#13		#_pre_Ship2
createnumber ship3 		#15		#170+6		#5		#13		#_pre_Ship3
createnumber ship4 		#2		#170+0		#6		#24		#_pre_Ship4
createnumber ship5 		#13		#170+3		#3		#3		#_pre_Ship5
createnumber ship6 		#9		#170+0		#3		#7		#_pre_Ship6
createnumber ship7 		#6		#170+9		#4		#7		#_pre_Ship7
createnumber ship8 		#11		#170+9		#4		#7		#_pre_Ship7
createnumber ship9 		#0		#170+7		#5		#11		#_pre_Ship8

crearPieza nave_anim 	#0		#115		#20		#24		#_pre_Ship_Full #0

createnumber ship 		#0		#162		#20		#8		#_pre_Ship
createnumber port 		#0		#194		#20		#6		#_pre_helipuerto
;; SPACESHIP GUI
;;

createKey level_up_1 	#32		#60		#24		#24		#_pre_level
createKey level_up_2	#58		#60		#9		#24		#_pre_up

;; ================================================================================
;; ================================================================================
;; PRIVATE DATA
;; ================================================================================
;; ================================================================================

;; ================================================================================
;; ================================================================================
;; PUBLIC FUNCTIONS
;; ================================================================================
;; ================================================================================

;; ======================================================================
;; *Init de las GUI del juego
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL, IX
;; SALIDA: --
;; ======================================================================
init_gui::
	ld 		ix, #bloque6_variables		;;| Cargamos el bloque negro de la zona de balas
	call 	paint_two_buffers			;;|	( IX / AF, BC, DE, HL / - )
										;;| Pintamos el bloque para las balas que esten pintadas

	ld 		ix, #bala1_variables		;;|
	ld 		0(ix), #0					;;|
	ld 		1(ix), #50					;;| Inicializamos a los valores por defecto de las balas GUI

	ld	ix,	#number3_variables			;;|
	ld	0(ix),	#2						;;|
	ld	1(ix),	#8						;;| Movemos el primer de los numeros a su posicion inicial

	ld	ix,	#number2_variables			;;|
	ld	0(ix),	#8						;;|
	ld	1(ix),	#8						;;| Movemos el segundo de los numeros a su posicion inicial

	ld	ix,	#number1_variables			;;|
	ld	0(ix),	#14						;;|
	ld	1(ix),	#8						;;| Movemos el tercer de los numeros a su posicion inicial

	ld 		a, #1						;;|
	ld 		ix, #numLv_variables		;;| Volvemos a poner el primer nivel en las variables
	call 	load_new_number				;;| ( A, IX / BC, D, HL / - )
	ret
;; ======================
;; Rellena las balas de la GUI
;; MODIFICA: IX, A
;; ======================
rellenar_balas::
    ld ix, #bala1_variables
    
    ld a, 0(ix)
    cp #15
    jr nz, add_x
    ld a, 1(ix)
    cp #60
    jr nz, add_y
    ret
    add_y:
    ld 0(ix), #3
    ld 1(ix), #60
    jr print_rellenar_balas
    add_x:
    ld a, 0(ix)
    add a, #3
    ld 0(ix), a
    print_rellenar_balas:
    call paint_two_buffers_entity
    jr rellenar_balas
	ret

;; ======================
;; Pintar el texto de level up
;; MODIFICA: IX, A
;; ======================
paint_text_lvl_up::
	ld ix, #level_up_1_variables
	call paint_entity
	ld ix, #level_up_2_variables
	call paint_entity
	ret

erase_text_lvl_up::
	ld ix, #level_up_1_variables
	call paint_two_buffers
	ld ix, #level_up_2_variables
	call paint_two_buffers
	ret


;; ======================
;; Borra una de las balas
;; MODIFICA: IX, A
;; ======================
erase_bala_gui::
    ld ix, #bala1_variables
    ld a, 0(ix)
    cp #0
    ret z
    call paint_two_buffers
    ld a, 0(ix)
    cp #3
    jr nz, sub_x
    ld a, 1(ix)
    cp #60
    jr nz, sub_x
    sub_y:
    ld 0(ix), #15
    ld 1(ix), #50
    ret
    sub_x:
    ld a, 0(ix)
    sub a, #3
    ld 0(ix), a
	ret

menu_draw::

	ld 		ix, #menu_variables
	call	paint_two_buffers

	ld ix, #bloque4_variables
	call paint_block
	
	ld ix, #bloque1_variables
	call paint_block
	
	ld ix, #bloque2_variables
	call paint_block

	ld ix, #bloque3_variables
	call paint_block

	ret
;; ======================================================================
;; *Pintamos el texto de left
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
menu_draw_left::
	push 	ix							;;  Nos almacenamos el valor de IX en la pila

	ld		ix,	#menu_variables			;;|
	call	paint_two_buffers			;;| ( - / AF, BC, DE, HL / - )
										;;| Borramos la imagen que habia anteriormente en pantalla

	ld		ix,	#left_k_variables		;;|
	ld		1(ix),	#90					;;| Mover la altura del texto
	call	paint_two_buffers_entity	;;|	( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto en pantalla

	pop 	ix							;; Volvemos a cargar IX desde la pila
	ret
;; ======================================================================
;; *Pintamos el texto de right
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
menu_draw_right::
	push 	ix							;;  Nos almacenamos el valor de IX en la pila

	ld 		ix, #left_k_variables		;;|
	call 	paint_two_buffers			;;| ( - / AF, BC, DE, HL / - )
										;;| Borramos el texto de left
	
	ld		ix,	#right_k_variables		;;|
	ld		1(ix),	#90					;;| Mover la altura del texto
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto en pantalla
	
	pop 	ix							;; Volvemos a cargar IX desde la pila
	ret
;; ======================================================================
;; *Pintamos el texto de up
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
menu_draw_up::
	push 	ix							;;  Nos almacenamos el valor de IX en la pila

	ld		ix, #right_k_variables		;;|
	call	paint_two_buffers			;;| ( - / AF, BC, DE, HL / - )
										;;| Borramos el texto de left

	ld		ix,	#up_k_variables			;;|
	ld		1(ix),	#90					;;| Mover la altura del texto
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto en pantalla
	
	pop 	ix							;; Volvemos a cargar IX desde la pila
	ret
;; ======================================================================
;; *Pintamos el texto de up
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
menu_draw_down::
	push 	ix							;;  Nos almacenamos el valor de IX en la pila

	ld		ix, #up_k_variables			;;|
	call 	paint_two_buffers			;;| ( - / AF, BC, DE, HL / - )
										;;| Borramos el texto de left

	ld		ix,	#down_k_variables		;;|
	ld		1(ix),	#90					;;| Mover la altura del texto
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto en pantalla

	pop 	ix							;; Volvemos a cargar IX desde la pila
	ret
;; ======================================================================
;; *Pintamos el texto de shoot left
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
menu_draw_shoot_left::
	push 	ix							;;  Nos almacenamos el valor de IX en la pila

	ld 		ix, #down_k_variables		;;|
	call	paint_two_buffers			;;| ( - / AF, BC, DE, HL / - )
										;;| Borramos el texto de left
	
	ld		ix,	#shoot_k_variables		;;|
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto en pantalla
	
	ld		ix,	#left_k_variables		;;|
	ld		1(ix),	#105				;;| Mover la altura del texto
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto en pantalla

	pop 	ix							;; Volvemos a cargar IX desde la pila						
	ret
;; ======================================================================
;; *Pintamos el texto de shoot right
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
menu_draw_shoot_right::
	push 	ix							;;  Nos almacenamos el valor de IX en la pila
	
	ld 		ix, #left_k_variables		;;|
	call 	paint_two_buffers			;;| ( - / AF, BC, DE, HL / - )
										;;| Borramos el texto de left

	ld		ix,	#right_k_variables		;;|
	ld		1(ix),	#105				;;| Mover la altura del texto
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto en pantalla
	
	pop 	ix							;; Volvemos a cargar IX desde la pila
	ret
;; ======================================================================
;; *Pintamos el texto de shoot up
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
menu_draw_shoot_up::
	push 	ix							;;  Nos almacenamos el valor de IX en la pila
	
	ld 		ix, #right_k_variables		;;|
	call 	paint_two_buffers			;;| ( - / AF, BC, DE, HL / - )
										;;| Boramos el texto de left
			
	ld		ix,	#up_k_variables			;;|
	ld		1(ix),	#105				;;| Mover la altura del texto
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto en pantalla

	pop 	ix							;; Volvemos a cargar IX desde la pila
	ret

menu_draw_title::
	push ix
	ld		ix,	#title_variables
	call	paint_two_buffers_entity
	ld		ix,	#menu_variables
	call	paint_two_buffers_entity
	ld		ix,	#twitter_variables
	call	paint_two_buffers_entity
	pop ix
	ret

gui_draw::

	ld ix, #bloque5_variables
	call paint_two_buffers

	ld ix, #bloque6_variables
	call paint_two_buffers

	ld ix, #bloque7_variables
	call paint_two_buffers

	ld ix, #number1_variables
	call paint_two_buffers_entity

	ld ix, #number2_variables
	call paint_two_buffers_entity

	ld ix, #number3_variables
	call paint_two_buffers_entity

	ld ix, #textoC_variables
	call paint_two_buffers_entity

	ld ix, #textoLV_variables
	call paint_two_buffers_entity

	ld ix, #numLv_variables
	call paint_two_buffers_entity

	ld ix, #textoV_variables
	call paint_two_buffers_entity

	ld ix, #guititle_variables
	call paint_two_buffers_entity

	ld	ix,	#bloque8_variables
	call paint_two_buffers

	ld	ix,	#ship_variables
	call paint_two_buffers_entity

	ld	ix,	#port_variables
	call paint_two_buffers_entity

	ld	ix,	#ship1_variables
	call paint_two_buffers

	ret

;; ======================================================================
;; *Pinta el nuevo numero de nivel
;; ENTRADA: A
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
gui_lvl_up::
	ld 		ix, #numLv_variables		;;| Cargamos en IX el numero a cambiar
	call 	load_new_number				;;| ( A, IX / BC, D, HL / - )
										;;| Cambiamos el sprite al nuevo numero
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el nuevo numero
	ret
;; ======================================================================
;; *Pinta el primer de los numeros de puntos
;; ENTRADA: A
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
gui_change_points_1::
	push 	ix							;;  Almacenamos IX en la pila

	ld 		ix, #number1_variables		;;| Cargamos en IX el numero a cambiar
	call 	load_new_number				;;| ( A, IX / BC, D, HL / - )
										;;| Cambiamos el sprite al nuevo numero
	call	 paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el nuevo numero

	pop 	ix							;; Almacenamos IX desde la pila
	ret
;; ======================================================================
;; *Pinta el segundo de los numeros de puntos
;; ENTRADA: A
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
gui_change_points_2::
	push 	ix							;;  Almacenamos IX en la pila

	ld 		ix, #number2_variables		;;| Cargamos en IX el numero a cambiar
	call 	load_new_number				;;| ( A, IX / BC, D, HL / - )
										;;| Cambiamos el sprite al nuevo numero
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el nuevo numero

	pop 	ix							;; Almacenamos IX desde la pila
	ret
;; ======================================================================
;; *Pinta el tercer de los numeros de puntos
;; ENTRADA: A
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
gui_change_points_3::
	push 	ix							;;  Almacenamos IX en la pila

	ld 		ix, #number3_variables		;;| Cargamos en IX el numero a cambiar
	call 	load_new_number				;;| ( A, IX / BC, D, HL / - )
										;;| Cambiamos el sprite al nuevo numero
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el nuevo numero

	pop ix								;; Almacenamos IX desde la pila
	ret
;; ======================================================================
;; *Pintamos las vidas actuales en la GUI
;; ENTRADA: IX
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
redraw_lifes::

	ld		a,	14(ix)					;;  Cargamos las vidas restantes en A
	push	af							;;  Guardamos AF en la pila

	ld		ix, #bloque7_variables		;;|
	call	paint_two_buffers			;;| Borramos las vidas anteriores

	pop		af							;;  Recuperamos A	
	dec		a							;;|
	ret		z							;;| Si no tenemos vidas extra, volvemos
	push	af							;;  La volvemos a guardar
	ld		ix, #vida1_variables		;;|
	ld		0(ix), #2					;;|
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos la primera vida
										
	pop		af							;;  Recuperamos A
	dec		a							;;|
	ret		z							;;| Si no tenemos ias exta, volvemos
	push	af							;;  La volvemos a guardar
	ld		ix, #vida1_variables		;;|
	ld 		0(ix), #6					;;| ...
	call	paint_two_buffers_entity
	
	pop		af
	dec		a
	ret		z
	push	af
	ld		ix, #vida1_variables
	ld 		0(ix), #10
	call	paint_two_buffers_entity
	
	pop		af
	dec		a
	ret		z
	ld		ix, #vida1_variables
	ld 		0(ix), #14
	call	paint_two_buffers_entity

	ret

;; ======================================================================
;; Pinta la pantalla de derrota y muestra la puntuacion
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
gameover_menu::
	call	erase_buffers				;;| ( - / BC, DE, HL / - )
										;;| Limpia todos los bytes de 8000 a FFFF

	ld		a,	#12						;;|
	call	change_music_speed			;;| ( A / HL / - )
										;;| Cambia la velocidad de la musica

	ld	 	hl, #_pre_palette_end		;;| Cargamos el puntero a la paleta
	ld 		de, #16						;;| Cargamos el numero de colores a cambiar
	call 	cpct_setPalette_asm			;;| ( DE, HL / AF, BC, DE, HL / - )
										;;| Cambiamos la paleta por la de final de partida

	ld		ix,	#number3_variables		;;|
	ld		0(ix),	#49					;;|
	ld		1(ix),	#76					;;| Cambiamos la posicionn del numero 3
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el tercer numero de puntuacion

	ld		ix,	#number2_variables		;;|
	ld		0(ix),	#55					;;|
	ld		1(ix),	#76					;;| Cambiamos la posicionn del numero 3
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el tercer numero de puntuacion

	ld		ix,	#number1_variables
	ld		0(ix),	#61
	ld		1(ix),	#76
	call 	paint_two_buffers_entity

	ld 		ix, #death_variables
	call 	paint_two_buffers_entity

	ld 		ix, #points_variables
	call 	paint_two_buffers_entity

	ld 		ix, #return_variables
	call 	paint_two_buffers_entity
	ret
;; ======================================================================
;; *Pinta la pantalla de victoria y muestra la puntuacion
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
youwin_menu::
	call	erase_buffers				;;| ( - / BC, DE, HL / - )
										;;| Limpia todos los bytes de 8000 a FFFF

	ld 		hl, #_pre_palette_end		;;| Cargamos el puntero a la paleta
	ld 		de, #16						;;| Cargamos el numero de colores a cambiar
	call 	cpct_setPalette_asm			;;| ( DE, HL / AF, BC, DE, HL / - )
										;;| Cambiamos la paleta por la de final de partida

	ld		ix,	#number3_variables		;;|
	ld		0(ix),	#49					;;|
	ld		1(ix),	#76					;;| Cambiamos la posicionn del numero 3
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el tercer numero de puntuacion

	ld		ix,	#number2_variables		;;|
	ld		0(ix),	#55					;;|
	ld		1(ix),	#76					;;| Cambiamos la posicion del numero 2
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el segundo numero de puntuacion

	ld		ix,	#number1_variables		;;|
	ld		0(ix),	#61					;;|
	ld		1(ix),	#76					;;| Cambiamos la posicion del numero 1
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el tercer numero de puntuacion

	ld 		ix, #win_variables			;;|
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto de victoria

	ld 		ix, #points_variables		;;|
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos el texto de puntuacion

	ld 		ix, #return_variables		;;|
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintams el texto de return
	ret
;; ======================================================================
;; *Pinta la parte del nivel correspondiente con el nivel
;; ENTRADA: A
;;		A 	->	Nivel Actual
;; MODIFICA: AF, BC, DE, HL
;; SALIDA: --
;; ======================================================================
draw_ship::
	;; -----------------------------------------	
	;; Primera pieza
	;; -----------------------------------------	
	lvl1:
	cp 		#2							;;|
	jr 		nz, lvl2					;;| Comprobamos si pasamos al nivel 2

	ld		ix,	#ship1_variables		;;| En el caso que pasemo al nivel pintamos la pieza correspondiente
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
	ret
	;; -----------------------------------------	
	;; Segunda pieza
	;; -----------------------------------------	
	lvl2:
	cp 		#3							;;|
	jr 		nz, lvl3					;;| Comprobamos si pasamos al nivel 3

	ld		ix,	#ship2_variables		;;| En el caso que pasemos al nivel pintamos la pieza correspondiente
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
	ret
	;; -----------------------------------------	
	;; Tercera pieza
	;; -----------------------------------------	
	lvl3:
	cp 		#4							;;|
	jr 		nz, lvl4					;;| Comprobamos si pasamos al nivel 4

	ld		ix,	#ship3_variables		;;| En el caso que pasemos al nivel pintamos la pieza correspondiente
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
	ret
	;; -----------------------------------------	
	;; Cuarta pieza
	;; -----------------------------------------	
	lvl4:
	cp 		#5							;;|
	jr 		nz, lvl5					;;| Comprobamos si pasamos al nivel 5

	ld		ix,	#ship4_variables		;;| En el caso que pasemos al nivel pintamos la pieza correspondiente
	call	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
	ret
	;; -----------------------------------------	
	;; Quinta pieza
	;; -----------------------------------------	
	lvl5:
	cp 		#6							;;|
	jr 		nz, lvl6					;;| Comprobamos si pasamos al nivel 6

	ld		ix,	#ship5_variables		;;| En el caso que pasemos al nivel pintamos la pieza correspondiente
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
	ret
	;; -----------------------------------------	
	;; Sexta pieza
	;; -----------------------------------------	
	lvl6:
	cp 		#7							;;|
	jr 		nz, lvl7					;;| Comprobamos si pasamos al nivel 7

	ld		ix,	#ship6_variables		;;| En el caso que pasemos al nivel pintamos la pieza correspondiente
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
	ret
	;; -----------------------------------------	
	;; Septima pieza
	;; -----------------------------------------	
	lvl7:
	cp 		#8							;;|
	jr 		nz, lvl8					;;| Comprobamos si pasamos al nivel 8

	ld		ix,	#ship7_variables		;;| En el caso que pasemos al nivel pintamos la piezas correspondiente
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
	ld		ix,	#ship8_variables		;;|	
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )

	ret
	;; -----------------------------------------	
	;; Octava pieza
	;; -----------------------------------------	
	lvl8:
	cp 		#9							;;|
	jr 		nz, lvl9					;;| Comprobamos si pasamos al nivel 9

	ld		ix,	#ship9_variables		;;| En el caso que pasemos al nivel pintamos la pieza correspondiente
	call 	paint_two_buffers_entity	;;| ( IX / AF, BC, DE, HL / - )
	ret
	;; -----------------------------------------	
	;; Novena pieza
	;; -----------------------------------------	
	lvl9:
	cp 		#10							;;|
	jr 		nz, lvl10					;;| Comprobamos si pasamos al nivel 10

										;;  En este caso no se pinta pieza al pasar directamente a la escena de victoria
	ret
	;; -----------------------------------------	
	;; Decima pieza
	;; -----------------------------------------	
	lvl10:
	cp 		#11							;;|
	ret 	nz							;;| Metodo extendido para poner mas niveles

	ret
;; ======================================================================
;; *Animacion de la nave espacil al ganar el juego
;; ENTRADA: --
;; MODIFICA: AF, BC, DE, HL, IX
;; SALIDA: --
;; ======================================================================
nave_animation::
	ld 		ix, #nave_anim_variables	;;  Cargamos en IX la nave
	call 	erase_entity				;;	( IX / AF, BC, DE, HL / - )
										;;  Borramos la nave
	;; -----------------------------------------
	;; Save last variables
	;; -----------------------------------------	
	ld 		a, enemy_x(ix)			;;|
	ld 		enemy_last_x(ix), a		;;| Guardamos la X del frame anterior

	ld 		a, enemy_y(ix)			;;|
	ld 		enemy_last_y(ix), a		;;| Guardamos la Y del fram anterior

	alterar_valor = .+1				
	ld 		a, #0x05				;;| Cargamos en A el contador de update
	dec 	a						;;|
	ld 		(alterar_valor), a		;;| Decrementamos el contador
	jr 		nz, pintar_nave			;;| Si el contador llega a 0 hacemos un update
	;; -----------------------------------------
	;; Update
	;; -----------------------------------------	
	ld 		a, #0x05				;;|
	ld 		(alterar_valor), a		;;| Volvemos a poner el contador a su valor inicial

	ld 		a, 0(ix)				;;| Cargamos la X de la nave
	inc 	a						;;|
	ld 		0(ix), a				;;| Incrementamos el valor
	add 	a, 2(ix)				;;| Cargamos en A la posicion de la nave mas su ancho
	sub 	#80						;;| Comprobamos si la nave se sale de la pantalla
	jr 		nz, pintar_nave
	ld 		0(ix), #0				;;  En el caso de que se pase ponemos la nave al inicio de la pantalla

	pintar_nave:
	;; -----------------------------------------
	;; Paint Nave
	;; -----------------------------------------	
	call 	paint_entity				;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos la nave
	;; -----------------------------------------
	;; Paint Cajas Negras
	;; -----------------------------------------
	ld 		ix, #cajawin_variables		;;|	
	call 	paint_block					;;| ( IX / AF, BC, DE, HL / - )
	ld 		ix, #cajawin2_variables		;;|
	call 	paint_block					;;| ( IX / AF, BC, DE, HL / - )
										;;| Pintamos dos bloques negros para que la nave desaparezca al pasar por ellos
	
	call cpct_waitVSYNC_asm				;;| ( - / AF, BC / - )
										;;| Nos esperamos a que el raster llegue abajo
	call cambiar_inicio_pantalla		;;| ( - / AF, BC, DE, HL / - )
										;;| Intercambiamos los buffers
	ret

;; ================================================================================
;; ================================================================================
;; PRIVATE FUNCTIONS
;; ================================================================================
;; ================================================================================

;; ======================================================================
;; *Carga en IX, el sprite correspondiente al numero pasado 
;; ENTRADA: A, IX
;; MODIFICA: BC, D, HL
;; SALIDA: --
;; ======================================================================
load_new_number:
	ld 		hl, #number_variables		;;  Cargamos en HL un puntero al array de numeros
	ld 		b, #0						;;|
	ld 		c, a						;;| Cargamos en BC el indice del array a cargar

	add 	hl, bc						;;|
	add 	hl, bc						;;| Movemos HL a la posicion correspondiente del array 

	ld 		d, (hl)						;;|
	ld 		6(ix), d					;;| Guardamos el byte bajo del sprite
	inc 	hl							;;| 
	ld 		d, (hl)						;;| Guardamos el byte alto del sprite
	ld 		7(ix), d					;;| Cargamos el sprite del numero en la variable
	ret

	