
;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of ProtonSmoke: An Amstrad CPC Shoot 'Em Up Game
;; Copyright (C) 2017 Daniel Finestrat Martinez (@DanielFinestrat)
;; Copyright (C) 2017 Angel Navarro Martinez (@EingelNavarro)
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.area _CODE


;; ================================================================================
;; ================================================================================
;; PRIVATE DATA
;; ================================================================================
;; ================================================================================
.include "cpctelera.h.s"
.globl _song_battletheme

;; ================================================================================
;; ================================================================================
;; PUBLIC FUNCTIONS
;; ================================================================================
;; ================================================================================
init_sfx::
	call	cpct_akp_SFXInit_asm
ret

stop_sfx::
	call cpct_akp_SFXStopAll_asm
ret

;;(1B L ) sfx_num	Number of the instrument in the SFX Song (>0), same as the number given to the instrument in Arkos Tracker.
;;(1B H ) volume	Volume [0-15], 0 = off, 15 = maximum volume.
;;(1B E ) note	Note to be played with the given instrument [0-143]
;;(1B D ) speed	Speed (0 = As original, [1-255] = new Speed (1 is fastest))
;;(2B BC) inverted_pitch	Inverted Pitch (-0xFFFF -> 0xFFFF).  0 is no pitch.  The higher the pitch, the lower the sound.
;;(1B A ) channel_bitmask	Bitmask representing channels to use for reproducing the sound (Ch.A = 001 (1), Ch.B = 010 (2), Ch.C = 100 (4))

play_Shoot_sfx::
	ld		l,	#4
	ld		h,	#13
	ld		e,	#65
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x100
	call	cpct_akp_SFXPlay_asm
ret

play_obtain_pup_sfx::
	ld		l,	#1
	ld		h,	#15
	ld		e,	#80
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x010
	call	cpct_akp_SFXPlay_asm
ret

play_menu_sfx::
	push ix
	push iy
	ld		l,	#1
	ld		h,	#15
	ld		e,	#80
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x010
	call	cpct_akp_SFXPlay_asm
	pop iy
	pop ix
ret

play_Shoot_pup_sfx::
	ld		l,	#4
	ld		h,	#15
	ld		e,	#50
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x100
	call	cpct_akp_SFXPlay_asm
ret

play_enemy_death_sfx::
	ld		l,	#3
	ld		h,	#15
	ld		e,	#75
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x010
	call	cpct_akp_SFXPlay_asm
ret

play_enemy_hit_sfx::
	push ix
	push iy
	ld		l,	#1
	ld		h,	#13
	ld		e,	#50
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x010
	call	cpct_akp_SFXPlay_asm
	pop iy
	pop ix
ret

play_player_death_sfx::
	ld		l,	#2
	ld		h,	#15
	ld		e,	#40
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x100
	call	cpct_akp_SFXPlay_asm
ret

play_lvl_sfx::
	ld		l,	#5
	ld		h,	#15
	ld		e,	#80
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x100
	call	cpct_akp_SFXPlay_asm
ret

play_pause_sfx::
	push ix
	push iy
	ld		l,	#6
	ld		h,	#14
	ld		e,	#73
	ld		d,	#0
	ld		bc,	#0x0000
	ld		a,	#0x100
	call	cpct_akp_SFXPlay_asm
	pop iy
	pop ix
ret